module Apihelpers::ApiAuth
	def warden
		env['warden']
	end

	def authenticated
		if warden.authenticated?
			return true
		elsif params[:api_token]
			user = User.find_by(api_token: params[:api_token])
			if user && user.valid_api_token?
				return true
			else
				error!('401 Unauthorized', 401)
			end
		else
	  		error!('401 Unauthorized', 401)
		end
	end



	def current_user
		if warden.user
			return warden.user
		else
			user = nil
			user = User.find_by(api_token: params[:api_token]) if params[:api_token]
			if user && user.valid_api_token?
				return user
			else
				return nil
			end
		end
	end

	def is_admin?
		current_user && current_user.type == "Admin"
	end

	def authenticated_user
		authenticated
		error!('401 Unauthorized', 401) unless current_user
	end

	def authenticated_admin
		authenticated
		error!('401 Unauthorized', 401) unless is_admin?
	end
end