module V1
  
  class Users < Grape::API

    helpers do
      include Apihelpers::ApiAuth
    end

    resource :myself do
      desc "returns current user"
      params do
        requires :api_token, type: String, desc: "Api access token"
      end
      get do
        authenticated_user
        present current_user, with: Vo::UserVo
      end

      desc "Delete current signed in user. Requires password for added security."
      params do 
        requires :api_token, type: String, desc: "Api access token"
        requires :password, type: String, desc: "User's password"
      end
      delete do
        authenticated_user
        if current_user.valid_password?(params[:password])
          current_user.destory!
          {message: "User has been deleted"}
        else
          {error: "Wrong password"}
        end
      end
    end

    resource :users do
      desc "Return a list of all users"
      params do
        requires :api_token, type: String, desc: "Api access token"
      end
      get do
        authenticated_admin
        users = User.all.order("name ASC")
        present users, with: Vo::UserVo
      end

      
    end

  end
end