module Shoppy
  class OptionsController < ApplicationController
    before_action :authenticate_admin!

    def index
    	@options = OptionsGroup.all
    end

    def new
      if (params[:name]) && (params[:name] != "") && (params[:display]) && (params[:display] != "") && (params[:optionsItems]) && (params[:optionsItems] != "")
        if OptionsHelper::create_options_group(params[:name], params[:display], params[:optionsItems])
          Log.newEvent("Option Groups", "Options group named '#{params[:name]}' was created", current_admin.name)
          flash[:notice] = "Options Group has been created!"
        else
          flash[:warning] = "Something went wrong. Try again later"
        end
      else
        flash[:warning] = "Please make sure you have entered the options' group name, display name, and the options."
      end
      redirect_to "/products/options"
    end

    def show
      og = OptionsGroup.find_by(id: params[:options_group_id])
      if og
        @options_group = og
      else
        page_not_found
      end
    end

    def edit
      @options_group = OptionsGroup.find_by(id: params[:options_group_id])
      if @options_group
        @options_group.name = params[:options_group][:name]
        @options_group.display = params[:options_group][:display]
        @options_group.items_string = params[:optionsItems]
        if @options_group.save
          Log.newEvent("Option Groups", "Options group named '#@options_group.name}' was updated", current_admin.name)
          flash[:notice] = "Options Group has been updated."
        else
          flash[:error] = @options_group.errors.messages
        end
        redirect_to '/products/options/' + @options_group.id.to_s
      else
        page_not_found
      end
    end

    def delete
      options_group = OptionsGroup.find_by(id: params[:options_group_id])
      if options_group
        options_group.destroy
        Log.newEvent("Option Groups", "Options group named '#options_group.name}' was deleted", current_admin.name)
        flash[:notice] = "Options' group has been deleted."
        redirect_to '/products/options'
      else
        page_not_found
      end
    end

  end
end