module Shoppy
  class SettingsController < ApplicationController
    before_action :authenticate_admin!

    def show
      @setting = Setting.first
    end

    def edit
      def edit
      @setting = Setting.first
      if @setting.update_attributes(setting_params)
        Log.newEvent("Settings", "Settings were updated", current_admin.name)
        flash[:notice] = "Settings have been updated."
      else
        flash[:errors] = @setting.errors.messages
      end
      redirect_to "/settings"
    end

    def setting_params
      params.require(:setting).permit(:app_name, :hostname, :base_url, :accounts_email_sender, :notification_email_sender, :currency_unit, :license_key)
    end
    end
  end
end