module Shoppy
  class ShipmentsController < ApplicationController
    before_action :authenticate_admin!

    def index
      if params[:order_id]
        @order = Order.find_by(id: params[:order_id])
        if @order
          @shipments = Shipment.where(order_id: params[:order_id])
        else
          page_not_found
        end
      else
        @shipments = Shipment.all
      end
    end

    def show
      s = Shipment.find_by(id: params[:shipment_id])
      if s
        @shipment = s
      else
        page_not_found
      end
    end

    def edit
      @shipment = Shipment.find_by(id: params[:shipment_id])
      (order = Order.find_by(id: params[:order_id])) if params[:order_id]
      if @shipment
        if params[:status] == "cancelled"
          if @shipment.status == "Processing"
            @shipment.status = "Cancelled"
            @shipment.save
            Log.newEvent("Shipments",  "shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was cancelled", current_admin.name)
            flash[:notice] = "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was cancelled"
          elsif @shipment.status == "Cancelled"
            flash[:warning] = "Shipment is already not cancelled"
          elsif @shipment.status == "Shipped" || @shipment.status == "Delivered"
            flash[:warning] = "Shipment is already shipped, so it can't be cancelled"
          else
            flash[:warning] = "Something went wrong. please try again later"
          end
        elsif params[:status] == "processing"
          if @shipment.status == "Cancelled"
            @shipment.status = "Processing"
            @shipment.save
            Log.newEvent("Shipment",  "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked processing.", current_admin.name)
            flash[:notice] = "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked processing."
          elsif @shipment.status == "Processing"
            flash[:warning] = "Shipment is already marked processing."
          elsif @shipment.status == "Shipped"
            flash[:warning] = "Shipment is already shipped, so it can't be edited"
          else
            flash[:warning] = "Something went wrong. please try again later"
          end
        elsif params[:status] == "shipped"
          if @shipment.status == "Processing"
            @shipment.status = "Shipped"
            @shipment.save
            Log.newEvent("Shipment",  "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked shipped.", current_admin.name)
            flash[:notice] = "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked shipped."
          elsif @shipment.status == "Cancelled"
            flash[:warning] = "Order is cancelled, hence can't be marked as shipped"
          elsif @shipment.status = "Shipped"
            flash[:notice] = "Shipment is already marked shipped."
          else
             flash[:warning] = "Something went wrong. please try again later"
          end
        elsif params[:status] == "delivered"
          if @shipment.status == "Shipped"
            @shipment.status = "Delivered"
            @shipment.delivery_date = Date.today
            @shipment.save
            Log.newEvent("Shipment",  "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked Delivered.", current_admin.name)
            flash[:notice] = "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was marked Delivered."
          else
            flash[:warning] = "Order has to be shipped first, before you mark it delivered"
          end
        else
          flash[:warning] = "Something went wrong. please try again later"
        end
        if params[:view] == "show"
          redirect_to "/shipments/#{@shipment.id}"
        else
          if order
            redirect_to "/orders/#{order.id}/shipments"
          else
            redirect_to "/shipments"
          end
        end
      else
        page_not_found
      end
    end

    def delete
      shipment = Shipment.find_by(id: params[:shipment_id])
      (order = Order.find_by(id: params[:order_id])) if params[:order_id]
      if shipment
        if shipment.status == "Cancelled" || shipment.status == "Processing"
          shipment.destroy
          Log.newEvent("Shipment",  "Shipment no. #{@shipment.id} for order no. '#{@shipment.order.id}' was deleted.", current_admin.name)
        elsif shipment.status == "Shipped" || shipment.status == "Delivered"
          flash[:warning] = "Shipment has already been shipped, so it can't be deleted."
        else
          flash[:warning] = "Something went wrong. please try again later"
        end
        if params[:view] == "show"
          redirect_to '/orders/#{order.id}/shipments/#{@shioment.id}'
        else
          if order
            redirect_to "/orders/#{order.id}/shipments"
          else
            redirect_to "/shipments"
          end
        end
      else
        page_not_found
      end
    end


  end
end