module Shoppy
module CartHelper
  def self.empty_cart_for_customer(customer)
    CartItem.transaction do
      cis = CartItem.where(customer_id: customer.id)
      cis.each do |ci|
        ci.destroy
      end
      return true
    end
  end

  def self.add_variant_to_customer_cart(customer, variant, quantity)
    ci = CartItem.find_by(customer_id: customer.id, variant_id: variant.od)
    if !ci
      ci = CartItem.new
      ci.customer = customer
      ci.variant = variant
    end
      ci.quantity += quantity
      return ci.save
  end

  def self.remove_variant_from_customer_cart(customer, variant)
    ci = CartItem.find_by(customer_id: customer.id, variant_id: variant.od)
    ci.destroy if ci
  end

  def self.update_variant_quantity_in_customer_cart(customer, variant, quantity)
    ci = CartItem.find_by(customer_id: customer.id, variant_id: variant.od)
    if ci
      ci.quantity = quantity
      ci.save
    end
    return ci
  end

  def self.convert_cart_to_order(customer)
    uc = customer.cart_items
    order = nil
    Order.transaction do
      o = Order.new
      o.customer = customer
      o.save
      order_total_price = 0.0
      uc.each do |cl|
        ol = OrderLine.new
        ol.order = o
        ol.variant = cl.variant
        ol.quantity = cl.quantity
        ol.price_per_one = cl.variant.price
        line_totalprice = ol.quantity * ol.price_per_one
        order_total_price += line_totalprice
        ol.save
      end
      o.total_price = order_total_price
      o.date = Date.today
      order = o.save
      CartHelper::empty_cart_for_customer(customer)
      OrdersHelper::calculate_points(o)
      return true
    end
  end

end
end