module Shoppy
  module OptionsHelper
    def self.create_options_group(group_name, display, options_names)
      items = options_names.split(',')
      OptionsGroup.transaction do
        g = OptionsGroup.new
        g.name = group_name.downcase.titleize
        g.display = display
        g.save
        items.each do |i|
          OptionsItem.create(name: i.to_s, options_group_id: g.id)
        end
        return g
      end
    end

    def self.items_to_string(options_group)
      ois = ""
      options_group.options_items.order("name ASC").each do |oi|
        ois += oi.name + ","
      end
      return ois[0..ois.length-2]
    end


    def self.update_options_items(options_group)
      o = options_group.optionsItems.split(',')
      n = options_group.items_string.split(',')
      o.each do |oi|
        if n.include?(oi) == false
          to_remove = OptionsItem.find_by(name: oi, options_group_id: options_group.id)
          to_remove.destroy if to_remove
        end
      end
      n.each do |ni|
        if o.include?(ni) == false
          OptionsItem.create(name: ni, options_group_id: options_group.id)
        end
      end
      return true
    end
  end
end