module Shoppy
  module ProductsHelper
    def self.add_options_groups_to_product(product, options_groups)
      product.options_groups += options_groups
      product.save
      vs = product.variants
      vs.each do |v|
        options_groups.each do |og|
          v.put_option(og.name, "")
        end
        v.save
      end
      return product
    end

    def self.remove_options_groups_from_product(product, options_groups)
      product.options_groups -= options_groups
      product.save
      vs = product.variants
      vs.each do |v|
        options_groups.each do |og|
          v.delete_option(og.name)
        end
        v.save
      end
      return product
    end

    def self.update_options_groups_for_product(product, options_groups)
      Product.transaction do
        original_groups = product.options_groups
        new_groups = options_groups
        added_groups = new_groups - original_groups
        removed_groups = original_groups - new_groups
        puts remove_options_groups_from_product(product, removed_groups)
        puts add_options_groups_to_product(product, added_groups)
        return true
      end
    end

    def self.createVariants_for_product(product, variants_names)
      variants_names.each do |vn|
        v = Variant.new
        v.name = vn
        v.product = product
        product.options_groups.each do |h|
          v.put_option(h.name, "")
        end
        v.save
      end
      return product
    end


    def self.convert_params_groups_to_objects(params)
      options_ids = params
      options = []
      options_ids.each do |o_id|
        o = OptionsGroup.find_by(id: o_id.to_i)
        (options += [o]) if o
      end
      return options
   end
  end
end