module Shoppy
  module ShipmentsHelper
    def self.prepare_shipment(order, order_lines, stock_location, customer_address)
      if(order.customer_address == customer_address.customer) && ((order_lines - order.orderlines).empty?)
        Shipment.transaction do
          s = Shipment.new
          s.order = order
          s.stock_location = stock_location
          s.order_lines = order_lines
          order_lines.each do |ol|
            InventoriesHelper::deduct_variant_from_stuck_location(ol.variant, ol.quantity, stock_location)
          end
          s.name      = customer_address.customer.name
          s.phone     = customer_address.customer.phone
          s.add_line1 = customer_address.add_line1
          s.add_line2 = customer_address.add_line2
          s.city      = customer_address.city
          s.state     = customer_address.state
          s.country   = customer_address.country
          s.zip       = customer_address.zip
          return s.save
        end
      else
        return false
      end
    end

    def self.ship_shipment(shipment, tracking_number)
      s = shipment
      s.tracking_number = tracking_number
      s.shipment_date = Date.today
      s.status = "Shipped"
      return s.save
    end

    def self.mark_shipment_delivered(shipment)
      s = shipment
      s.status = "Delivered"
      s.delivery_date = Date.today
      return s.save
    end
  end
end