module Shoppy
  class Brand < ActiveRecord::Base
    ## Relationships
    has_many :products, dependent: :nullify

    has_attached_file :brand_image,
      :path => ":rails_root/public/uploads/brands/:id_:style_:filename",
      :url => "/uploads/brands/:id_:style_:filename",
      :default_url => "/system/no_brand.png"

    ## Validators
    validates_attachment	:brand_image,
    						presence: true,
    						content_type: { content_type: /\Aimage\/.*\Z/ },
    						size: { less_than: 1.megabyte }

    validates :name, presence: true
    validates :name, length: { in: 2..100, too_short: "must have at least %{count} letters", too_long: "must have at most %{count} letters" }
    validates :name, uniqueness: true


  end
end