module Shoppy::Concerns::Models::Promotional
  extend ActiveSupport::Concern

  # For every model that you want to make promotioanl,
  # Add the following attributes to the model:
  #     float   :reg_price, null: false
  #     float   :promo_price, null: true
  #     date    :promo_price_starts_on, null: true
  #     date    :promo_price_ends_on, null: true



  def promotional_price?
    if self.promo_price && (self.promo_price > 0) && (self.promo_price_starts_on..self.promo_price_ends_on).cover?(Time.now) && (self.reg_price > self.promo_price)
      return self.promo_price
    else
      return false
    end
  end

  def price_info
      p = {reg_price: self.reg_price, promo_price: self.promotional_price?}
      return p
  end

  def price
    self.promotional_price? || self.reg_price
  end

  def set_promotion!(price, begin_date, end_date)
    self.promo_price = price
    self.promo_price_starts_on = begin_date
    self.promo_price_ends_on = end_date
    self.save
  end
end