module Shoppy::Concerns::Models::Taggable
  extend ActiveSupport::Concern

  def add_tags!(*args)
    tags = args
    tags.each do |tag|
      if Tag.exists?(name: tag)
        self.tags += [tag]
      else
        new_tag = Tag.create(name: tag)
        self.tags += [new_tag]
      end
    end
    self.save
  end

  def remove_tags!(*args)
    tags = args
    tags.each do |tag|
      if self.tags.include?(Tag.find_by(name: tag))
        self.tags -= [Tag.find_by(name: tag)]
      end
    end
    self.save
  end

  module ClassMethods

    def by_tag(tag)
      tag.products
    end

    def by_tag_name(tagname)
      tag = Tag.find_by(name: tagname)
      if tag
        self.by_tag(tag)
      else
        return nil
      end
    end

  end

end