module Shoppy
  class Order < ActiveRecord::Base
    ## Relationships
    has_many    :order_lines, dependent: :destroy
    has_many    :shipments, dependent: :destroy
    belongs_to  :customer
    belongs_to  :payment_method


    ## Validators
    validates :total_price, presence: true
    validates :total_price, :numericality => { :greater_than_or_equal_to => 0 }
    validates :status,    inclusion: {:in => ["Pending", "Approved", "Shipped", "Cancelled", "Delivered"], message: "Must be 'Pending', 'Processing', 'Shipped', 'Cancelled' or 'Delivered'"}
  end
end