module Shoppy
  class OrderLine < ActiveRecord::Base
    ## Relationships
    belongs_to  :order
    belongs_to  :variant
    belongs_to  :shipment

    ## Validators
    validates :price_per_one, presence: true
    validates :price_per_one, :numericality => { :greater_than_or_equal_to => 0 }
    validates :quantity,      presence: true
    validates :quantity,      :numericality => { :greater_than_or_equal_to => 0 }


  end
end