module Shoppy
  class PaymentMethod < ActiveRecord::Base
    ## Relationships
    has_many    :orders, dependent: :nullify

    ## Filters
    before_save :caps

    ## Validators
    validates :name, presence: true
    validates :name, length: { in: 2..50, too_short: "must have at least %{count} letters", too_long: "must have at most %{count} letters" }
    validates :name, uniqueness: true

    def caps
      self.name = self.name.downcase.titleize
    end

  end
end