module Shoppy
  class Review < ActiveRecord::Base
    ## Relationships
    belongs_to :customer
    belongs_to :product

    ## Validators
    validates_numericality_of :rate, only_integer: true, message: "can only be an integer"
    validates_inclusion_of    :rate, in: 0..5, message: "can only be between 0 and 5."

  end
end