module Shoppy
  class Shipment < ActiveRecord::Base
    ## Relationships
    has_many    :order_lines, dependent: :nullify
    belongs_to  :order
    belongs_to  :stock_location

    ## Validation
    validates   :status,    inclusion: {:in => ["Processing", "Shipped", "Cancelled", "Delivered"], message: "Must be 'Processing', 'Shipped', 'Cancelled' or 'Delivered'"}
  end
end