  class CreateOrderLines < ActiveRecord::Migration
  def change
    create_table :order_lines do |t|
      t.references  :order
      t.references  :variant
      t.integer     :quantity
      t.decimal     :price_per_one, precision: 8, scale: 2,  null: false, default: 0
      t.boolean     :shipped, null: false, default: false

      t.timestamps
    end
    add_index :order_lines, [:order_id, :variant_id], unique: true, name: "OrderVariantConstraint"
  end
end
