class CreateSettings < ActiveRecord::Migration
  def change
    create_table :settings do |t|
      t.string        :app_name,                    null: false, default: "Shoppy"
      t.string        :hostname,                    null: false, default: "example.com"
      t.string        :base_url,                    null: false, default: "http://example.com"
      t.string        :accounts_email_sender,       null: false, default: "accounts@example.com"
      t.string        :notification_email_sender,   null: false, default: "shoppy@example.com"
      t.string        :currency_unit,               null: false, default: "$"
      t.string        :license_key,                 null: false, default: ""

      t.integer       :token_expiry_hours,          null: false, default: 5

      t.timestamps
    end
  end

  def migrate(direction)
    super
    # Create default Settings
    Setting.create() if direction == :up
  end
end
