require 'httmultiparty'

module Shoppy
  @api_base = 'https://api.fourteeninch.com/v1/shoppy'

  class << self
    attr_accessor :api_base
  end

  def self.api_url(url='')
    "#{@api_base}/#{url}"
  end

  class Client
    def self.auth(hostname, license)
      begin
        response = self.get('validate', {:domain => hostname, :license => license})
        return response.parsed_response
      rescue => e
        return 'error' => e.message
      end
    end

    def self.get(path, params = nil)
      self.execute(:get, path, params)
    end

    def self.post(path, params)
      self.execute(:post, path, params)
    end

    def self.put(path, params)
     self.execute(:put, path, params)
    end

    def self.delete(path, params = nil)
      self.execute(:delete, path, params)
    end

    def self.execute(method, path, params = nil)
      begin
        request = HTTMultiParty.send(method, Shoppy.api_url(path), { query: params, timeout: 300 })
        if request.respond_to?('parsed_response')
          return request.parsed_response
        else
          return request
        end
      rescue => e
        return 'error' => e.message # error
      end
    end
  end
end